#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Master Template Importer
# DIZ: Enables you to specify a master template. This master template will be implemented throughout all PowerSeek templates. The master template will act like a frame with for example your graphics, menu bars, etc.
# GRAPHIC: ic_template.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi";

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use globaltmpl;
#use psfp;
&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
# not below if's - else bypassed...
print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "wizard1") {&wizard1;}
if ($q->param('fct') eq "implement") {&implement;}
if ($q->param('fct') eq "restore") {&restore;}
if ($q->param('fct') eq "restore2") {&restore2;}



sub restore
{

$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Restore Default Templates", qq[
The templates that will be restored are the templates that are normally used by default when PowerSeek is installed.<BR><BR>
<b>Note that it will overwrite all previous templates used by PowerSeek.</b>
<form method="POST" action="$admin_url/p_tmpglobal.cgi">
<input type="hidden" name="fct" value="restore2">Are you sure? <input type="submit" value="  Yes  " name="B1">
</form>
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>

];


}




sub restore2
{

opendir(DIR,"$data_dir");
@files = readdir(DIR);
foreach $filename (@files)
	{
	if (substr($filename, length($filename) - 4, 4) eq ".def")
		{
			$orignfn = substr($filename, 0, length($filename) - 4);
			$orignfn = $orignfn . ".html";
			
			$original_templ = acs::get_file_contents("$data_dir/$filename");
			open (DF, "> $data_dir/$orignfn");
				print DF $original_templ;
			close (DF);
			
		}
	}


$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Default PowerSeek Templates Restored", qq[
<a href="$admin_url/p_tmpglobal.cgi">Click Here to Continue</a>
]); 


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox

</body>
</html>
];

}






sub implement
{

### UPLOAD FILE

		### CHECK IF UPLOAD DIR EXISTS
		$upload_dir = "$data_dir/tmp";
		if ((-e $upload_dir) < 1) {
		mkdir ($upload_dir, $default_permissions);
		chmod($default_permissions,"$upload_dir","$upload_dir"); }
	
		$upload_filename = $q->param('attatch1'); 
		$ufname = "$data_dir/tmp/temp.html";

		### DO UPLOAD
		$upload_filehandle = $q->param('attatch1');
		open (UPLOADFILE, ">$ufname"); 
		binmode UPLOADFILE; 
		  while ( <$upload_filehandle> )
			 {
		    print UPLOADFILE;
			 } 	
		close UPLOADFILE;		


### CHECK FOR ERRORS

$master_tmpl = acs::get_file_contents("$data_dir/tmp/temp.html");

if ($master_tmpl !~ /!!psdata!!/i)
	{
	acs::problem_popup("The master template you uploaded does not contain the !!psdata!! variable.");
	}


if ($master_tmpl !~ /!!pagetitle!!/i)
	{
	acs::problem_popup("The master template you uploaded does not contain the !!pagetitle!! variable.");
	}
	

$def_templates = get_global_templates globaltmpl;

@template_names = globaltmpl::get_tnames;


#### IMPLEMENT TEMPLATES


foreach $item (@template_names)
	{
		
		($iname, $pagetitle) = split (/:/, $item);
		
		$tmp_tmpl = $master_tmpl;
		
		$tmdata = $def_templates->{$iname};
		
		$tmp_tmpl =~ s/!!psdata!!/$tmdata/;
		$tmp_tmpl =~ s/!!pagetitle!!/$pagetitle/;		
		
		$filename = "$data_dir/" . $iname . ".html";
		
		open (ODPP, "> $filename");
			print ODPP $tmp_tmpl;
		close (ODPP);
	
	}






$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Global Template Implemented.", qq[
<a href="$admin_url/p_tmpglobal.cgi">Click Here to Continue</a>
]);



print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];



}






sub wizard1
{


$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Implement a Global Template", qq[
Please read the instruction below and upload a template (HTML file)
]);

print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox


<p><strong>Step 1 - Create an HTML file that will serve as a frame </strong></p>

<blockquote>
  <p>Create a normal HTML file. This file could contain your company logo, navigational
  buttons or links, etc. Let's say for example the HTML file you create looks like this: </p>
  <p><img src="$web_url/wiz1.jpg"> </p>
  <p>&nbsp; </p>
</blockquote>

<p><strong>Step 2 - Add !!pagetitle!! word to HTML file</strong></p>
<blockquote>
  <p>Between the &lt;TITLE&gt; tags of the HTML file you just created place the  word !!pagetitle!!</p>
  <p>This  word will be replaced by the 'Titles' of templates or pages being viewed by end users.</p>
</blockquote>
<p>&nbsp;</p>
<p><strong>Step 3 - Place the words !!psdata!! inside the HTML page you created. </strong></p>
<blockquote>
  <p>Now insert the word !!psdata!! inside the HTML file where you would like PowerSeek to
  place it's functions &amp; options. </p>
  <p><img src="$web_url/wiz2.jpg"> </p>
  <p>&nbsp; </p>
</blockquote>

<p><strong>Step 4 - Correctly link up images </strong></p>

<blockquote>
  <p>You must reference images with the full path to where the images are situated. In other
  words, upload the images to your web site. Then view the source of the HTML file you
  created above and supply the full URL paths to where you uploaded the images on your web
  site - for all images. <br>
  &nbsp; <br>
  For example: </p>
  <blockquote>
    <p><strong>&lt;img src=&quot;someimage.gif&quot;&gt; will not work. </strong><br>
    &nbsp; <br>
    You have to <strong>indicate the entire URL </strong>where someimage.gif is located. For
    example: <br>
    &nbsp;&nbsp;&nbsp;&nbsp; <br>
    <strong>&lt;img src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt; </strong><br>
    &nbsp;&nbsp;&nbsp; <br>
    The <strong>&lt;img </strong>is an HTML tag indicating that you want to insert an image in
    the HTML page. The <strong>src= </strong>part indicates that you want to specify the
    location of the image to be inserted. Some web editors will support inserting images from
    a web url and some won't. If your web editor does not support this, insert the image into
    the HTML page like usual and, when finished, edit the the HTML source code and manually
    insert the URL path's to the images. Ensure that the images are on the server for the URL
    path's you specify. </p>
    <blockquote>
      <p><strong>Example: Editing the HTML source code: </strong></p>
    </blockquote>
    <blockquote>
      <p><strong>Replace &lt;img src=&quot;someimage.gif&quot;&gt; with <br>
      &lt;img src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt; </strong></p>
    </blockquote>
  </blockquote>
</blockquote>

<p><strong>&nbsp; </strong></p>

<p><strong>Step 5 - Upload the file you created. </strong></p>

<blockquote>
  <p>After you have uploaded the file, all templates used by PowerSeek will be updated with
  the HTML file you uploaded. In other words, the file you uploaded will be used as the
  frame for all pages that your end-users will view. </p>
  <p><strong>Warning: </strong>Uploading your HTML file will replace any previous templates.
  In other words, if you have made changes to the existing templates then it will be lost. </p>
</blockquote>

<blockquote>
  <form method="POST" action="$admin_url/p_tmpglobal.cgi" ENCTYPE="multipart/form-data">
    <input type="hidden" name="fct" value="implement"><p><input type="file" name="attatch1"
    size="50"> </p>
    <p><input type="submit" value="   Upload   " name="B1"> </p>
  </form>
</blockquote>

</body>
</html>
];


}




sub start
{

$hbox = acs::get_heading_box("$web_url/ic_template_long.gif", "Implement a Global Template", qq[
With this functionality you can use one template (as a frame) that will be implemented with all the templates of PowerSeek. This template must be a normal HTML file. The Global Template Functionality is a quick and easy way to implement your own look & feel to the pages/templates your end-users will see. With the Global Template functionality you can include your own logo's/graphics/menu bar/etc. Please keep in mind that you can customize all individual templates and that all Text and HTML displayed to users is fully customizable. You can customize individual pages/templates by clicking the 'Template Manager' tab when in the control panel.
]);
 

print qq[

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">  
</head>
<body>
$hbox


<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD" height="46">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><img
    src="$web_url/ic_pop2.gif"> </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><strong><a
    href="$admin_url/p_tmpglobal.cgi?fct=wizard1">Start the Wizard to Implement a Global
    Template </a></strong><br>
    (Note that any changes to existing templates will be lost!) </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><img
    src="$web_url/ic_backup1.gif"> </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><strong><a
    href="$admin_url/p_tmpglobal.cgi?fct=restore">Restore PowerSeek's Original Templates </a><br>
    </strong>(Note that any changes to existing templates will be lost!) </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

</body>
</html>

];


}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

